﻿Copyright (c) (2013) Fluke Corporation.                  All rights reserved.
=============================================================================
INSTRUMENT:            Sub Get Accuracy (base units) /LVLG
DATE:                  2013-09-27 09:45:26
AUTHOR:                Fluke
REVISION:              $Revision: 4485 $
ADJUSTMENT THRESHOLD:  70%
NUMBER OF TESTS:       1
NUMBER OF LINES:       102
=============================================================================
#
#  Procedure Author:
#        DAC
#
#  Compatibility:
#        MET/CAL 8.0 or later
#
#  This procedure is intended for use with MET/CAL® calibration software;
#  the terms and conditions set forth in your MET/CAL license apply to this
#  procedure.
#
#  Due to Fluke's policy of continuously updating our products, this procedure
#  may contain minor differences in methods used and/or specifications to
#  those found in the manual or other documentation. While every effort has
#  been made to ensure that this procedure is accurate, Fluke cannot be held
#  responsible for the consequences of error or omissions found within this
#  procedure.
#
#  The copyright in this procedure is owned by Fluke Corporation.
#
 STEP    FSC    RANGE NOMINAL        TOLERANCE     MOD1        MOD2  3  4 CON

# If cardinal point parameter is frequency...
  1.001  IF           ZCMPI(@LVLG_CPT, "Freq")
# Specify Nominal value of parameter.
  1.002  MATH         @LVLG_Nominal = @LVLG_Freq
# Specify third (frequency) and fourth (amplitude) ACCV2 arguments.
  1.003  MATH         FreqBase = BASE(@LVLG_Freq)
  1.004  MATH         AmplBase = BASE(@LVLG_Ampl)
# Specify LVLG frequency mode string in ModeStr from ini file.
  1.005  MATH         ModeStr = RINFE(@LVLG_DevName, "ModeStringFreq")

# Check for options that affect frequency.
# If LVLG has options that affect frequency...
  1.006  IF           NOT(EMPTY(@LVLG_FreqOpt))
# Retrieve frequency-affecting options from variable.
# Append option to mode string in ModeStr to specify correct mode string.
  1.007  MATH         ModeStr = ModeStr & " " & @LVLG_FreqOpt
  1.008  ENDIF

# Retrieve LVLG frequency accuracy.
  1.009  MATH         Acc = ACCV2(@LVLG_DevName, ModeStr, FreqBase, AmplBase)

# If cardinal point parameter is amplitude...
  1.010  ELSEIF       ZCMPI(@LVLG_CPT, "Ampl")
# Specify Nominal value of parameter.
  1.011  MATH         @LVLG_Nominal = @LVLG_Ampl
# Specify third and fourth ACCV2 arguments (level and frequency).
  1.012  MATH         FreqBase = BASE(@LVLG_Ampl)
  1.013  MATH         AmplBase = BASE(FreqBase)
# Specify LVLG amplitude mode string in ModeStr from ini file.
  1.014  MATH         ModeStr = RINFE(@LVLG_DevName, "ModeStringAmpl")

# Check for options that affect amplitude.
# If LVLG has options that affect amplitude...
  1.015  IF           NOT(EMPTY(@LVLG_AmplOpt))
# Retrieve amplitude-affecting options from variable.
# Append option to mode string in ModeStr to specify correct mode string.
  1.016  MATH         ModeStr = ModeStr & " " & @LVLG_AmplOpt
  1.017  ENDIF

  1.018  ELSEIF       ZCMPI(@LVLG_CPT, "Flat")
# Specify Nominal value of parameter.
  1.019  MATH         @LVLG_Nominal = @LVLG_Ampl
# Specify third and fourth ACCV2 arguments (level and frequency).
  1.020  MATH         FreqBase = BASE(@LVLG_Ampl)
  1.021  MATH         AmplBase = BASE(FreqBase)
# Specify LVLG amplitude mode string in ModeStr from ini file.
  1.022  MATH         ModeStr = RINFE(@LVLG_DevName, "ModeStringFlat")

# Check for options that affect flatness.
# If LVLG has options that affect flatness...
  1.023  IF           NOT(EMPTY(@LVLG_AmplOpt))
# Retrieve amplitude-affecting options from variable.
# Append option to mode string in ModeStr to specify correct mode string.
  1.024  MATH         ModeStr = ModeStr & " " & LVLG_AmplOpt
  1.025  ENDIF

# Retrieve LVLG amplitude accuracy.
  1.026  MATH         Acc = ACCV2(@LVLG_DevName, ModeStr, AmplBase, FreqBase)
  1.027  ENDIF

  1.028  MATH         Confidence = VGET("CONF")

# VGET query returns empty string if CONF is set to default (2).
  1.029  IF           EMPTY(Confidence)
  1.030  MATH         Confidence = 2
  1.031  ENDIF

  1.032  MATH         @LVLG_Acc = (Acc / CONF(@LVLG_DevName)) * Confidence

  1.033  END
