﻿Copyright (c) (2013) Fluke Corporation.                  All rights reserved.
=============================================================================
INSTRUMENT:            Sub Get Accuracy (base units) /SWPG
DATE:                  2013-09-27 09:48:52
AUTHOR:                Fluke
REVISION:              $Revision: 4486 $
ADJUSTMENT THRESHOLD:  70%
NUMBER OF TESTS:       1
NUMBER OF LINES:       86
=============================================================================
#
#  Procedure Author:
#        DAC
#
#  Compatibility:
#        MET/CAL 8.0 or later
#
#  This procedure is intended for use with MET/CAL® calibration software;
#  the terms and conditions set forth in your MET/CAL license apply to this
#  procedure.
#
#  Due to Fluke's policy of continuously updating our products, this procedure
#  may contain minor differences in methods used and/or specifications to
#  those found in the manual or other documentation. While every effort has
#  been made to ensure that this procedure is accurate, Fluke cannot be held
#  responsible for the consequences of error or omissions found within this
#  procedure.
#
#  The copyright in this procedure is owned by Fluke Corporation.
#
 STEP    FSC    RANGE NOMINAL        TOLERANCE     MOD1        MOD2  3  4 CON

# -----  Cardinal Point: Frequency  ---------------
  1.001  IF           ZCMPI(@SWPG_CPT, "Freq")
# Specify Nominal value of parameter.
  1.002  MATH         Nominal = @SWPG_Freq
# Specify third and fourth ACCV2 arguments (level and frequency).
  1.003  MATH         L[3] = BASE(@SWPG_Freq)
  1.004  MATH         L[4] = BASE(@SWPG_Ampl)
# Specify SWPG frequency mode string in AccMode from ini file.
  1.005  MATH         AccMode = RINFE(@SWPG_DevName, "ModeStringFreq")

# Check for options that affect frequency.
  1.006  IF           NOT(EMPTY(@SWPG_FreqOpt))
# Append option to mode string.
  1.007  MATH         AccMode = AccMode & " " & @SWPG_FreqOut
  1.008  ENDIF

# -----  Cardinal Point: Amplitude  ---------------
  1.009  ELSEIF       ZCMPI(@SWPG_CPT, "Ampl")

  1.010  MATH         Nominal = @SWPG_Ampl
  1.011  MATH         L[3] = BASE(@SWPG_Ampl)
  1.012  MATH         L[4] = BASE(@SWPG_Freq)
  1.013  MATH         AccMode = RINFE(@SWPG_DevName, "ModeStringAmpl")

  1.014  IF           NOT(EMPTY(@SWPG_AmplOpt))
  1.015  MATH         AccMode = AccMode & " " & @SWPG_AmplOut
  1.016  ENDIF

# -----  Cardinal Point: Flatness  ----------------
  1.017  ELSEIF       ZCMPI(@SWPG_CPT, "Flat")

  1.018  MATH         Nominal = @SWPG_Ampl
  1.019  MATH         L[3] = BASE(@SWPG_Ampl)
  1.020  MATH         L[4] = BASE(@SWPG_Freq)
  1.021  MATH         AccMode = RINFE(@SWPG_DevName, "ModeStringFlat")

  1.022  IF           NOT(EMPTY(@SWPG_AmplOpt))
  1.023  MATH         AccMode = AccMode & " " & @SWPG_AmplOut
  1.024  ENDIF

  1.025  ENDIF

# Retrieve SWPG accuracy at desired nominal parameter.
  1.026  MATH         Acc = ACCV2(@SWPG_DevName, AccMode, L[3], L[4])
  1.027  MATH         Confidence = VGET("CONF")

# VGET query returns empty string if CONF is set to default (2).
  1.028  IF           EMPTY(Confidence)
  1.029  MATH         Confidence = 2
  1.030  ENDIF

  1.031  MATH         @SWPG_Acc = (Acc / CONF(@SWPG_DevName)) * Confidence

  1.032  END
