﻿Copyright (c) (2013) Fluke Corporation.                  All rights reserved.
=============================================================================
INSTRUMENT:            Sub Get Accuracy (base units) /UWSG
DATE:                  2013-09-27 09:51:52
AUTHOR:                Fluke
REVISION:              $Revision: 4487 $
ADJUSTMENT THRESHOLD:  70%
NUMBER OF TESTS:       1
NUMBER OF LINES:       91
=============================================================================
#
#  Procedure Author:
#        DAC
#
#  Compatibility:
#        MET/CAL 8.0 or later
#
#  This procedure is intended for use with MET/CAL® calibration software;
#  the terms and conditions set forth in your MET/CAL license apply to this
#  procedure.
#
#  Due to Fluke's policy of continuously updating our products, this procedure
#  may contain minor differences in methods used and/or specifications to
#  those found in the manual or other documentation. While every effort has
#  been made to ensure that this procedure is accurate, Fluke cannot be held
#  responsible for the consequences of error or omissions found within this
#  procedure.
#
#  The copyright in this procedure is owned by Fluke Corporation.
#
 STEP    FSC    RANGE NOMINAL        TOLERANCE     MOD1        MOD2  3  4 CON

# -----  Cardinal Point: Frequency  ---------------
  1.001  IF           ZCMPI(@UWSG_CPT, "Freq")
# Specify Nominal value of parameter.
  1.002  MATH         @UWSG_Nominal = @UWSG_Freq
# Specify third and fourth ACCV2 arguments (frequency and amplitude).
  1.003  MATH         FreqBase = BASE(@UWSG_Freq)
  1.004  MATH         AmplBase = BASE(@UWSG_Ampl)
# Specify UWSG frequency mode string in ModeStr from ini file.
  1.005  MATH         ModeStr = RINFE(@UWSG_DevName, "ModeStringFreq")

# Check for option that affects accuracy.
  1.006  IF           NOT(EMPTY(@UWSG_FreqOpt))
# Append option to mode string.
  1.007  MATH         ModeStr = ModeStr & " " & @UWSG_FreqOpt
  1.008  ENDIF        ; Options

# Retrieve UWSG frequency accuracy.
  1.009  MATH         Acc = ACCV2(@UWSG_DevName, ModeStr, FreqBase, AmplBase)

# -----  Cardinal Point: Amplitude  ---------------
  1.010  ELSEIF       ZCMPI(@UWSG_CPT, "Ampl")
  1.011  MATH         @UWSG_Nominal = @UWSG_Ampl
  1.012  MATH         FreqBase = BASE(@UWSG_Freq)
  1.013  MATH         AmplBase = BASE(@UWSG_Ampl)
  1.014  MATH         ModeStr = RINFE(@UWSG_DevName, "ModeStringAmpl")

  1.015  IF           NOT(EMPTY(@UWSG_AmplOpt))
  1.016  MATH         ModeStr = ModeStr & " " & @UWSG_AmplOpt
  1.017  ENDIF        ; Options

  1.018  MATH         Acc = ACCV2(@UWSG_DevName, ModeStr, AmplBase, FreqBase)

# -----  Cardinal Point: Flatness  ----------------
  1.019  ELSEIF       ZCMPI(@UWSG_CPT, "Flat")

  1.020  MATH         @UWSG_Nominal = @UWSG_Ampl
  1.021  MATH         FreqBase = BASE(@UWSG_Freq)
  1.022  MATH         AmplBase = BASE(@UWSG_Ampl)
  1.023  MATH         ModeStr = RINFE(@UWSG_DevName, "ModeStringFlat")

  1.024  IF           NOT(EMPTY(@UWSG_AmplOpt))
  1.025  MATH         ModeStr = ModeStr & " " & @UWSG_AmplOpt
  1.026  ENDIF        ; Options

  1.027  MATH         Acc = ACCV2(@UWSG_DevName, ModeStr, AmplBase, FreqBase)

  1.028  ENDIF        ; Cardinal point parameters.

# Get value of VSET parameter, confidence value.
  1.029  MATH         Confidence = VGET("CONF")

# VGET query returns empty string if CONF is set to default (2).
  1.030  IF           EMPTY(Confidence)
  1.031  MATH         Confidence = 2
  1.032  ENDIF

  1.033  MATH         @UWSG_Acc = (Acc / CONF(@UWSG_DevName)) * Confidence

  1.034  END
