﻿Copyright (c) 2021 Fluke Calibration                        MET/CAL Procedure
=============================================================================
INSTRUMENT:            Sub Initiate Continuous /LFCTR
INSTRUMENT:            Sub Gate On /LFCTR
INSTRUMENT:            Sub Gate Off /LFCTR
INSTRUMENT:            Sub Fetch /LFCTR
DATE:                  2021-11-10 10:20:16
AUTHOR:                Fluke
REVISION:              $Revision: 2619 $
ADJUSTMENT THRESHOLD:  70%
NUMBER OF TESTS:       1
NUMBER OF LINES:       68
CONFIGURATION:         Agilent 53132A
=============================================================================
#
#  Procedure Author:
#        DAC
#
#  Required Files:
#        user_config_instr.ini
#
#  This procedure is intended for use with MET/CAL® calibration software;
#  the terms and conditions set forth in your MET/CAL license apply to this
#  procedure.
#
#  Due to Fluke's policy of continuously updating our products, this procedure
#  may contain minor differences in methods used and/or specifications to
#  those found in the manual or other documentation. While every effort has
#  been made to ensure that this procedure is accurate, Fluke cannot be held
#  responsible for the consequences of error or omissions found within this
#  procedure.
#
#  The copyright in this procedure is owned by Fluke Corporation.
#
#  Parameters       Values
#  ---------------  ---------------------------------------------------------
#  see sub_driver_lfctr.txt
#
 STEP    FSC    RANGE NOMINAL        TOLERANCE     MOD1        MOD2  3  4 CON

  1.001  IF           PSUBI("Initiate Continuous")
  1.002  MATH         Parameter = "InitiateContinuous"
  1.003  ELSEIF       PSUBI("Gate On")
  1.004  MATH         Parameter = "GateOn"
  1.005  ELSEIF       PSUBI("Gate Off")
  1.006  MATH         Parameter = "GateOff"
  1.007  ELSEIF       PSUBI("Fetch")
  1.008  MATH         Parameter = "Fetch"
  1.009  ELSE
  1.010  DISP         Subprocedure not found!
  1.011  END
  1.012  ENDIF

  1.013  MATH         @LFCTR_Cmd = RINFE(@LFCTR_ProgSecName, Parameter)

  1.014  IF           ZCMPI(@LFCTR_FSC, "SCPI")
  1.015  SCPI         [@LFCTR][T5000][V @LFCTR_Cmd]
  1.016  ELSEIF       ZCMPI(@LFCTR_FSC, "IEEE2")
  1.017  IEEE2        [@LFCTR][T5000][V @LFCTR_Cmd]
  1.018  ELSE
  1.019  IEEE         [@LFCTR][T5000][V @LFCTR_Cmd]
  1.020  ENDIF

  1.021  IF           PSUBI("Fetch")
  1.022  IEEE         [@LFCTR][I]
  1.023  ENDIF

  1.024  END
